using System;
using System.Threading;
using System.Threading.Tasks;
using Implab.Components;

namespace Implab.Test {
    public class MockPollComponent : PollingComponent {

        public Func<CancellationToken,Task> PollWorker { get; set;}

        public Func<CancellationToken, Task> StartWorker { get; set; }

        public Func<CancellationToken, Task> StopWorker { get; set; }

        public MockPollComponent(bool initialized) : base(initialized) {
        }

        protected async override Task Poll(CancellationToken ct) {
            if(PollWorker!= null)
                await PollWorker.Invoke(ct);
        }

        protected async override Task StopInternalAsync(CancellationToken ct) {
            if (StopWorker != null)
                await StopWorker.Invoke(ct);
        }

        protected async override Task StartInternalAsync(CancellationToken ct) {
            if (StartWorker != null)
                await StartWorker.Invoke(ct);
        }


    }
}